function rollDice() {
	var rollNum = document.getElementById('roll_number').value;
	if(rollNum == 0) {
		// Display keep buttons on first roll
		displayKeepButtons();
	}
	if(rollNum < numOfRolls) {
		//removeUnselectedDice();
		
		// Increment roll number
		document.getElementById('roll_number').value++;
		// Decrease rolls remaining
		document.getElementById('rolls_remaining').value--;
		
		// Create 5 random dice for roll
		var r1, r2, r3, r4, r5;
		r1 = Math.floor((Math.random() * 6) + 1);
		r2 = Math.floor((Math.random() * 6) + 1);
		r3 = Math.floor((Math.random() * 6) + 1);
		r4 = Math.floor((Math.random() * 6) + 1);
		r5 = Math.floor((Math.random() * 6) + 1);
		
		var r1keep, r2keep, r3keep, r4keep, r5keep;
		r1keep = document.getElementById('keep1').style.visibility == 'hidden';
		r2keep = document.getElementById('keep2').style.visibility == 'hidden';
		r3keep = document.getElementById('keep3').style.visibility == 'hidden';
		r4keep = document.getElementById('keep4').style.visibility == 'hidden';
		r5keep = document.getElementById('keep5').style.visibility == 'hidden';
		
		// Set values incase kept, unless kept from previous roll
		if(r1keep) {
			r1 = document.getElementById('setKeep1').value;
		} else {
			document.getElementById('setKeep1').value = r1;
		}
		if(r2keep) {
			r2 = document.getElementById('setKeep2').value;
		} else {
			document.getElementById('setKeep2').value = r2;
		}
		if(r3keep) {
			r3 = document.getElementById('setKeep3').value;
		} else {
			document.getElementById('setKeep3').value = r3;
		}
		if(r4keep) {
			r4 = document.getElementById('setKeep4').value;
		} else {
			document.getElementById('setKeep4').value = r4;
		}
		if(r5keep) {
			r5 = document.getElementById('setKeep5').value;
		} else {
			document.getElementById('setKeep5').value = r5;
		}
		
		// Display keep buttons
		//$('#keep_buttons').show();
						
		// Display dice
		displayDice(r1, 1, r1keep);
		displayDice(r2, 2, r2keep);
		displayDice(r3, 3, r3keep);
		displayDice(r4, 4, r4keep);
		displayDice(r5, 5, r5keep);
		
		// Display keep buttons
		$('#keep_buttons').show();
	}
	if(rollNum == (numOfRolls - 1)) {
		// Hide roll, reset and keep buttons after 3rd roll
		document.getElementById('roll_button').style.visibility = 'hidden';
		document.getElementById('reset_button').style.visibility = 'hidden';
		document.getElementById('keep_buttons').style.display = "none";
		// Display scorecard
		$('#score_card').show();
	}
	setTimeout(function() {
		displayPossibleScores();
	}, 1000);
}
function displayDice(r, i, rkeep) {
	/*if(r == 1) {
		show_image("1.png", i, rkeep);
	} else if(r == 2) {
		show_image("2.png", i, rkeep);
	} else if(r == 3) {
		show_image("3.png", i, rkeep);
	} else if(r == 4) {
		show_image("4.png", i, rkeep);
	} else if(r == 5) {
		show_image("5.png", i, rkeep);
	} else if(r == 6) {
		show_image("6.png", i, rkeep);
	} else {}*/
	show_image(r, i, rkeep);
}
function show_image(src, i, rkeep) {
	/*
	var img = document.createElement("img");
	var screenSize = $(window).width();
	//var diceSize = screenSize * .15; //15%
	var diceSize = 58;	//58px
	img.src = src;
	img.width = diceSize;
	img.height = diceSize;
	img.alt = alt;

	// This next line will just add it to the <body> tag
	//document.body.appendChild(img);
	document.getElementById('dice_images').appendChild(img);	// Add to dice_images div
	*/
	
	var bgPosition = (src - 1) * (-54);
	
	if(!rkeep) {
		/*img.style.visibility = 'hidden';
		setTimeout(function() {
			img.style.visibility = '';
		}, 300);*/
		var interval = setInterval(function() {
			var bgPos = $('#dice'+i).css('background-position');
			if(parseInt(bgPos) >= -270) {
				$('#dice'+i).css('background-position', parseInt(bgPos) - 54 + "px");
			} else {
				$('#dice'+i).css('background-position', "0px");
			}
		}, 50);
		setTimeout(function() {
			clearInterval(interval);
			$('#dice'+i).css('background-position', bgPosition+"px");
		}, 750);
	} else {	
		$('#dice'+i).css('background-position', bgPosition+"px");
	}
}
function removeUnselectedDice() {
	// Delete old images			
	var images = document.getElementsByTagName('img');
	while(images.length > 0) {
		images[0].parentNode.removeChild(images[0]);
	}
}
function displayKeepButtons() {
	document.getElementById('keep1').style.visibility = 'visible';
	document.getElementById('keep2').style.visibility = 'visible';
	document.getElementById('keep3').style.visibility = 'visible';
	document.getElementById('keep4').style.visibility = 'visible';
	document.getElementById('keep5').style.visibility = 'visible';
}
function hideKeepButtons() {
	document.getElementById('keep1').style.visibility = 'hidden';
	document.getElementById('keep2').style.visibility = 'hidden';
	document.getElementById('keep3').style.visibility = 'hidden';
	document.getElementById('keep4').style.visibility = 'hidden';
	document.getElementById('keep5').style.visibility = 'hidden';
}
function resetKeepButtons() {
	document.getElementById('keep1').style.visibility = 'visible';
	document.getElementById('keep2').style.visibility = 'visible';
	document.getElementById('keep3').style.visibility = 'visible';
	document.getElementById('keep4').style.visibility = 'visible';
	document.getElementById('keep5').style.visibility = 'visible';
}
function onKeep1() {
	document.getElementById('keep1').style.visibility = 'hidden';
}
function onKeep2() {
	document.getElementById('keep2').style.visibility = 'hidden';
}
function onKeep3() {
	document.getElementById('keep3').style.visibility = 'hidden';
}
function onKeep4() {
	document.getElementById('keep4').style.visibility = 'hidden';
}
function onKeep5() {
	document.getElementById('keep5').style.visibility = 'hidden';
}
function calcAces() {
	var sum = 0;
	var r = new Array();
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		if(r[i] == 1) {
			sum++;
		}
	}
	
	return sum;
}
function clickAces() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('aces_points').style.backgroundColor != "yellow") {					
			// Caclulate sum of 1s
			var sum = calcAces();					
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your ones.");
				confirm = window.confirm("You are taking a "+ sum +" on your ones.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('aces_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('aces_label').style.backgroundColor = "yellow";
				document.getElementById('aces_points').style.backgroundColor = "yellow";						
									
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen aces.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcTwos() {
	var sum = 0;
	var r = new Array();
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		if(r[i] == 2) {
			sum += 2;
		}
	}
	
	return sum;
}
function clickTwos() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('twos_points').style.backgroundColor != "yellow") {					
			// Caclulate sum of 2s
			var sum = calcTwos();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your twos.");
				confirm = window.confirm("You are taking a "+ sum +" on your twos.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {					
				document.getElementById('twos_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('twos_label').style.backgroundColor = "yellow";
				document.getElementById('twos_points').style.backgroundColor = "yellow";
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen twos.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcThrees() {
	var sum = 0;
	var r = new Array();
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		if(r[i] == 3) {
			sum += 3;
		}
	}
	
	return sum;
}
function clickThrees() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('threes_points').style.backgroundColor != "yellow") {					
			// Caclulate sum of 3s
			var sum = calcThrees();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your threes.");
				confirm = window.confirm("You are taking a "+ sum +" on your threes.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {					
				document.getElementById('threes_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('threes_label').style.backgroundColor = "yellow";
				document.getElementById('threes_points').style.backgroundColor = "yellow";
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen threes.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcFours() {
	var sum = 0;
	var r = new Array();
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		if(r[i] == 4) {
			sum += 4;
		}
	}
	
	return sum;
}
function clickFours() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('fours_points').style.backgroundColor != "yellow") {					
			// Caclulate sum of 4s
			var sum = calcFours();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your fours.");
				confirm = window.confirm("You are taking a "+ sum +" on your fours.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('fours_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('fours_label').style.backgroundColor = "yellow";
				document.getElementById('fours_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen fours.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcFives() {
	var sum = 0;
	var r = new Array();
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		if(r[i] == 5) {
			sum += 5;
		}
	}
	
	return sum;
}
function clickFives() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('fives_points').style.backgroundColor != "yellow") {					
			// Caclulate sum of 5s
			var sum = calcFives();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your fives.");
				confirm = window.confirm("You are taking a "+ sum +" on your fives.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('fives_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('fives_label').style.backgroundColor = "yellow";
				document.getElementById('fives_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen fives.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcSixes() {
	var sum = 0;
	var r = new Array();
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		if(r[i] == 6) {
			sum += 6;
		}
	}
	
	return sum;
}
function clickSixes() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('sixes_points').style.backgroundColor != "yellow") {					
			// Caclulate sum of 6s
			var sum = calcSixes();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your sixes.");
				confirm = window.confirm("You are taking a "+ sum +" on your sixes.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('sixes_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('sixes_label').style.backgroundColor = "yellow";
				document.getElementById('sixes_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen sixes.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calc3kind() {
	var sum = 0;
	var r = new Array();
	var counter;
	var bool = false;
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		counter = 1;
		for(var j=0; j<r.length; j++) {
			if(i != j) {
				if(r[i] == r[j]) {
					counter++;
				}
			}
		}
		if(counter >= 3) {
			bool = true;
			break;
		}
	}
	
	if(bool) {
		// Calculate sum of dice if 3 match
		for(var i=0; i<r.length; i++) {
			sum += +r[i];
		}
	}
	
	return sum;
}
function click3kind() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('3kind_points').style.backgroundColor != "yellow") {					
			// Check if 3 dice match
			var sum = calc3kind();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your 3 of a kind.");
				confirm = window.confirm("You are taking a "+ sum +" on your 3 of a kind.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('3kind_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('3kind_label').style.backgroundColor = "yellow";
				document.getElementById('3kind_points').style.backgroundColor = "yellow";
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen 3 of a kind.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calc4kind() {
	var sum = 0;
	var r = new Array();
	var counter;
	var bool = false;
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	for(var i=0; i<r.length; i++) {
		counter = 1;
		for(var j=0; j<r.length; j++) {
			if(i != j) {
				if(r[i] == r[j]) {
					counter++;
				}
			}
		}
		if(counter >= 4) {
			bool = true;
			break;
		}
	}
	
	if(bool) {
		// Calculate sum of dice if 4 match
		for(var i=0; i<r.length; i++) {
			sum += +r[i];
		}
	}
	
	return sum;
}
function click4kind() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('4kind_points').style.backgroundColor != "yellow") {					
			// Check if 4 dice match
			var sum = calc4kind();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your 4 of a kind.");
				confirm = window.confirm("You are taking a "+ sum +" on your 4 of a kind.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('4kind_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('4kind_label').style.backgroundColor = "yellow";
				document.getElementById('4kind_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen 4 of a kind.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcFullhouse() {
	var sum = 0;
	var r = new Array();
	
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	
	r.sort();
	r = r.join("");
	if (/(.)\1{2}(.)\2|(.)\3(.)\4{2}/.test(r)) {
		sum = 25;
	}
	
	return sum;
}
function clickFullhouse() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('fullhouse_points').style.backgroundColor != "yellow") {					
			// Check if 3 dice match and the other 2 also match
			var sum = calcFullhouse();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your full house.");
				confirm = window.confirm("You are taking a "+ sum +" on your full house.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('fullhouse_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('fullhouse_label').style.backgroundColor = "yellow";
				document.getElementById('fullhouse_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen full house.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcSmstraight() {
	var sum = 0;
	var r = new Array();
	var r2 = new Array();

	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;

	$.each(r, function(i, el){
		if($.inArray(el, r2) === -1) r2.push(el);
	});

	r2.sort();
	r2 = r2.join("");
	if (/1234|2345|3456/.test(r2)) {
		sum = 30;
	}
	
	return sum;
}
function clickSmstraight() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('smstraight_points').style.backgroundColor != "yellow") {					
			// Check if 4 consecutive dice
			var sum = calcSmstraight();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your small straight.");
				confirm = window.confirm("You are taking a "+ sum +" on your small straight.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('smstraight_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('smstraight_label').style.backgroundColor = "yellow";
				document.getElementById('smstraight_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen small straight.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcLgstraight() {
	var sum = 0;
	var r = new Array();

	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;

	r.sort();
	r = r.join("");
	if (/12345|23456/.test(r)) {
		sum = 40;
	}
	
	return sum;
}
function clickLgstraight() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('lgstraight_points').style.backgroundColor != "yellow") {					
			// Check if 5 consecutive dice
			var sum = calcLgstraight();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your large straight.");
				confirm = window.confirm("You are taking a "+ sum +" on your large straight.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('lgstraight_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('lgstraight_label').style.backgroundColor = "yellow";
				document.getElementById('lgstraight_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen large straight.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcYahtzee() {
	var sum = 0;
	var r = new Array();
	var bool = false;
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	
	if(r[0] == r[1] && r[0] == r[2] && r[0] == r[3] && r[0] == r[4]) {
		bool = true;
	}
	
	if(bool) {
		// If Yahtzee give 50 points
		sum = 50;
	}
	
	return sum;
}
function clickYahtzee() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('yahtzee_points').style.backgroundColor != "yellow") {					
			// Check if all 5 dice match
			var sum = calcYahtzee();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your Yahtzee.");
				confirm = window.confirm("You are taking a "+ sum +" on your Yahtzee.");
			//} else {
			/*if(sum != 0) {
				// Display bonus yahtzee if first yahtzee is hit
				$('#bonus_yahtzee_row').show();
			}*/
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				if(sum != 0) {
					// Display bonus yahtzee if first yahtzee is hit
					$('#bonus_yahtzee_row').show();
				}
				document.getElementById('yahtzee_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('yahtzee_label').style.backgroundColor = "yellow";
				document.getElementById('yahtzee_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen Yahtzee.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcYahtzeeBonus() {
	var sum = 0;
	var r = new Array();
	var bool = false;
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	
	if(r[0] == r[1] && r[0] == r[2] && r[0] == r[3] && r[0] == r[4]) {
		bool = true;
	}
	
	if(bool) {
		// If bonus Yahtzee give 100 points
		sum = 100;
	}
	
	return sum;
}
function clickYahtzeeBonus() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('yahtzee_bonus_points').style.backgroundColor != "yellow") {					
			// Check if all 5 dice match
			var sum = calcYahtzeeBonus();
			
			// If 0, don't let user select bonus yahtzee
			var confirm = true;
			if(sum == 0) {
				window.alert("You can only use bonus yahtzee if you get another Yahtzee.");
				confirm = false;
			} else {
				confirm = window.confirm("You are taking a "+ sum +" on your Bonus Yahtzee.");
				// Display bonus yahtzee 2 if first bonus yahtzee is hit
				//$('#bonus_yahtzee_row2').show();
			}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				// Display bonus yahtzee 2 if first bonus yahtzee is hit
				$('#bonus_yahtzee_row2').show();
				document.getElementById('yahtzee_bonus_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('yahtzee_bonus_label').style.backgroundColor = "yellow";
				document.getElementById('yahtzee_bonus_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen Bonus Yahtzee.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function clickYahtzeeBonus2() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('yahtzee_bonus_points2').style.backgroundColor != "yellow") {					
			// Check if all 5 dice match
			var sum = calcYahtzeeBonus();
			
			// If 0, don't let user select bonus yahtzee
			var confirm = true;
			if(sum == 0) {
				window.alert("You can only use bonus yahtzee if you get another Yahtzee.");
				confirm = false;
			} else {
				confirm = window.confirm("You are taking a "+ sum +" on your Bonus Yahtzee.");
				// Display bonus yahtzee 3 if first bonus yahtzee 2 is hit
				//$('#bonus_yahtzee_row3').show();
			}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				// Display bonus yahtzee 3 if first bonus yahtzee 2 is hit
				$('#bonus_yahtzee_row3').show();
				document.getElementById('yahtzee_bonus_points2').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('yahtzee_bonus_label2').style.backgroundColor = "yellow";
				document.getElementById('yahtzee_bonus_points2').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen Bonus Yahtzee.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function clickYahtzeeBonus3() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('yahtzee_bonus_points3').style.backgroundColor != "yellow") {					
			// Check if all 5 dice match
			var sum = calcYahtzeeBonus();
			
			// If 0, don't let user select bonus yahtzee
			var confirm = true;
			if(sum == 0) {
				window.alert("You can only use bonus yahtzee if you get another Yahtzee.");
				confirm = false;
			} else {
				confirm = window.confirm("You are taking a "+ sum +" on your Bonus Yahtzee.");
				// Display bonus yahtzee 2 if first bonus yahtzee is hit
				//$('#bonus_yahtzee_row4').show();
			}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				// Display bonus yahtzee 2 if first bonus yahtzee is hit
				$('#bonus_yahtzee_row4').show();
				document.getElementById('yahtzee_bonus_points3').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('yahtzee_bonus_label3').style.backgroundColor = "yellow";
				document.getElementById('yahtzee_bonus_points3').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen Bonus Yahtzee.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function clickYahtzeeBonus4() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('yahtzee_bonus_points4').style.backgroundColor != "yellow") {					
			// Check if all 5 dice match
			var sum = calcYahtzeeBonus();
			
			// If 0, don't let user select bonus yahtzee
			var confirm = true;
			if(sum == 0) {
				window.alert("You can only use bonus yahtzee if you get another Yahtzee.");
				confirm = false;
			} else {
				confirm = window.confirm("You are taking a "+ sum +" on your Bonus Yahtzee.");
				// Display bonus yahtzee 2 if first bonus yahtzee is hit
				//$('#bonus_yahtzee_row5').show();
			}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				// Display bonus yahtzee 2 if first bonus yahtzee is hit
				$('#bonus_yahtzee_row5').show();
				document.getElementById('yahtzee_bonus_points4').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('yahtzee_bonus_label4').style.backgroundColor = "yellow";
				document.getElementById('yahtzee_bonus_points4').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen Bonus Yahtzee.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function clickYahtzeeBonus5() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('yahtzee_bonus_points5').style.backgroundColor != "yellow") {					
			// Check if all 5 dice match
			var sum = calcYahtzeeBonus();
			
			// If 0, don't let user select bonus yahtzee
			var confirm = true;
			if(sum == 0) {
				window.alert("You can only use bonus yahtzee if you get another Yahtzee.");
				confirm = false;
			} else {
				confirm = window.confirm("You are taking a "+ sum +" on your Bonus Yahtzee.");
			}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('yahtzee_bonus_points5').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('yahtzee_bonus_label5').style.backgroundColor = "yellow";
				document.getElementById('yahtzee_bonus_points5').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen Bonus Yahtzee.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function calcChance() {
	var sum = 0;
	var r = new Array();
	r[0] = document.getElementById('setKeep1').value;
	r[1] = document.getElementById('setKeep2').value;
	r[2] = document.getElementById('setKeep3').value;
	r[3] = document.getElementById('setKeep4').value;
	r[4] = document.getElementById('setKeep5').value;
	
	for(var i=0; i<r.length; i++) {
		sum += +r[i];
	}
	
	return sum;
}
function clickChance() {
	if(document.getElementById('roll_number').value != 0) {
		if(document.getElementById('chance_points').style.backgroundColor != "yellow") {					
			// Add dice together
			var sum = calcChance();
			
			// If 0, let user confirm
			var confirm = true;
			//if(sum == 0) {
				//confirm = window.confirm("You are taking a 0 on your chance.");
				confirm = window.confirm("You are taking a "+ sum +" on your chance.");
			//}
			// If user does not cancel confirm, or has points, then continue
			if(confirm) {
				document.getElementById('chance_points').innerHTML = sum;
				// Highlight after chosen
				document.getElementById('chance_label').style.backgroundColor = "yellow";
				document.getElementById('chance_points').style.backgroundColor = "yellow";	
				
				// Hide keep buttons incase not 3rd roll
				document.getElementById('keep_buttons').style.display = "none";
				// Reset roll count incase not 3rd roll
				document.getElementById('roll_number').value = 0;
				
				//End of turn check
				updates();
			}
		} else {
			window.alert("You have already chosen chance.");
		}
	} else {
		window.alert("You have not rolled yet.");
	}
}
function updates() {
	playAudio('/android_asset/www/ting.mp3');
	// Bring back roll and reset button
	document.getElementById('roll_button').style.visibility = 'visible';
	document.getElementById('reset_button').style.visibility = 'visible';
	// Remove dice
	removeUnselectedDice();
	
	// Remove assitance totals
	var scores = document.getElementsByClassName('points');
	for(var i=0; i<scores.length; i++) {
		scores[i].style.color = "black";
		if(scores[i].style.backgroundColor != "yellow") {
			scores[i].innerHTML = "";
			scores[i].style.backgroundColor = "white";
			// If bonus yahtzee row, keep sky blue
			if(scores[i].id == "yahtzee_bonus_points" || scores[i].id == "yahtzee_bonus_points2" || scores[i].id == "yahtzee_bonus_points3" || scores[i].id == "yahtzee_bonus_points4" || scores[i].id == "yahtzee_bonus_points5") {
				scores[i].style.backgroundColor = "SkyBlue";
			}
		}
	}
	
	// Update upper total
	var upperTotal = +document.getElementById('aces_points').innerHTML +
					+document.getElementById('twos_points').innerHTML +
					+document.getElementById('threes_points').innerHTML +
					+document.getElementById('fours_points').innerHTML +
					+document.getElementById('fives_points').innerHTML +
					+document.getElementById('sixes_points').innerHTML;
	document.getElementById('total_score_points').innerHTML = upperTotal;
	// If upperTotal >= 63 then add bonus 35
	var bonus = 0;
	if(upperTotal >= 63) {
		bonus = 35;
	}
	document.getElementById('bonus_points').innerHTML = bonus;
	// Total Upper = upper total + bonus
	var totalUpper = +upperTotal + +bonus;
	document.getElementById('total_upper_points').innerHTML = totalUpper;
	//document.getElementById('total_upper2_points').innerHTML = totalUpper; //Bottom total upper
	
	// Update lower total
	var lowerTotal = +document.getElementById('3kind_points').innerHTML +
					+document.getElementById('4kind_points').innerHTML +
					+document.getElementById('fullhouse_points').innerHTML +
					+document.getElementById('smstraight_points').innerHTML +
					+document.getElementById('lgstraight_points').innerHTML +
					+document.getElementById('yahtzee_points').innerHTML +
					+document.getElementById('yahtzee_bonus_points').innerHTML +
					+document.getElementById('yahtzee_bonus_points2').innerHTML +
					+document.getElementById('yahtzee_bonus_points3').innerHTML +
					+document.getElementById('yahtzee_bonus_points4').innerHTML +
					+document.getElementById('yahtzee_bonus_points5').innerHTML +
					+document.getElementById('chance_points').innerHTML;
	document.getElementById('total_lower_points').innerHTML = lowerTotal;
					
	// Update Grand Total
	var grandTotal = +totalUpper + +lowerTotal;
	document.getElementById('grand_total_points').innerHTML = grandTotal;
	
	// Check if user has finished game
	endGameCheck();
}
function endGameCheck() {
	var bool = true;
	
	// Check if score card is full
	var tableTop = document.getElementById('table_top');
	var tableBottom = document.getElementById('table_bottom');
	for (var r = 0, n = tableTop.rows.length; r < n; r++) {
		for (var c = 0, m = tableTop.rows[r].cells.length; c < m; c++) {
			// Game ends even if no bonus yahtzees
			if(tableTop.rows[r].id != 'bonus_yahtzee_row' && tableTop.rows[r].id != 'bonus_yahtzee_row2' && tableTop.rows[r].id != 'bonus_yahtzee_row3' && tableTop.rows[r].id != 'bonus_yahtzee_row4' && tableTop.rows[r].id != 'bonus_yahtzee_row5') {
				if(tableTop.rows[r].cells[c].innerHTML == '') {
					bool = false;
				}
			}
		}
	}
	for (var r = 0, n = tableBottom.rows.length; r < n; r++) {
		for (var c = 0, m = tableBottom.rows[r].cells.length; c < m; c++) {
			// Game ends even if no bonus yahtzees
			if(tableBottom.rows[r].id != 'bonus_yahtzee_row' && tableBottom.rows[r].id != 'bonus_yahtzee_row2' && tableBottom.rows[r].id != 'bonus_yahtzee_row3' && tableBottom.rows[r].id != 'bonus_yahtzee_row4' && tableBottom.rows[r].id != 'bonus_yahtzee_row5') {
				if(tableBottom.rows[r].cells[c].innerHTML == '') {
					bool = false;
				}
			}
		}
	}
	
	if(bool) {
		//window.alert("Game Over. Refresh to play again!");
		$('#dice_wrapper').hide();
		$('#play_again').show();
		//Check and update high score
		checkUpdateHighScore();
	} else {
		$('#dice_wrapper').hide();
		$('#spin, #spinner').show();
	}
}
function displayPossibleScores() {
	var scores;
	// Aces
	scores = document.getElementById('aces_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('aces_points').innerHTML = calcAces();
		document.getElementById('aces_points').style.color = "red";
	}
	// Twos
	scores = document.getElementById('twos_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('twos_points').innerHTML = calcTwos();
		document.getElementById('twos_points').style.color = "red";
	}
	// Threes
	scores = document.getElementById('threes_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('threes_points').innerHTML = calcThrees();
		document.getElementById('threes_points').style.color = "red";
	}
	// Fours
	scores = document.getElementById('fours_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('fours_points').innerHTML = calcFours();
		document.getElementById('fours_points').style.color = "red";
	}
	// Fives
	scores = document.getElementById('fives_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('fives_points').innerHTML = calcFives();
		document.getElementById('fives_points').style.color = "red";
	}
	// Sixes
	scores = document.getElementById('sixes_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('sixes_points').innerHTML = calcSixes();
		document.getElementById('sixes_points').style.color = "red";
	}
	// 3 of a kind
	scores = document.getElementById('3kind_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('3kind_points').innerHTML = calc3kind();
		document.getElementById('3kind_points').style.color = "red";
	}
	// 4 of a kind
	scores = document.getElementById('4kind_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('4kind_points').innerHTML = calc4kind();
		document.getElementById('4kind_points').style.color = "red";
	}
	// Full House
	scores = document.getElementById('fullhouse_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('fullhouse_points').innerHTML = calcFullhouse();
		document.getElementById('fullhouse_points').style.color = "red";
	}
	// Small Straight
	scores = document.getElementById('smstraight_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('smstraight_points').innerHTML = calcSmstraight();
		document.getElementById('smstraight_points').style.color = "red";
	}
	// Large Straight
	scores = document.getElementById('lgstraight_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('lgstraight_points').innerHTML = calcLgstraight();
		document.getElementById('lgstraight_points').style.color = "red";
	}
	// Yahtzee
	scores = document.getElementById('yahtzee_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('yahtzee_points').innerHTML = calcYahtzee();
		document.getElementById('yahtzee_points').style.color = "red";
	}
	// Bonus Yahtzee, if visible
	if(document.getElementById('bonus_yahtzee_row').style.display != "none") {
		scores = document.getElementById('yahtzee_bonus_points').style.backgroundColor;
		if(scores != "yellow") {
			document.getElementById('yahtzee_bonus_points').innerHTML = calcYahtzeeBonus();
			document.getElementById('yahtzee_bonus_points').style.color = "red";
		}
	}
	// Bonus Yahtzee 2, if visible
	if(document.getElementById('bonus_yahtzee_row2').style.display != "none") {
		scores = document.getElementById('yahtzee_bonus_points2').style.backgroundColor;
		if(scores != "yellow") {
			document.getElementById('yahtzee_bonus_points2').innerHTML = calcYahtzeeBonus();
			document.getElementById('yahtzee_bonus_points2').style.color = "red";
		}
	}
	// Bonus Yahtzee 3, if visible
	if(document.getElementById('bonus_yahtzee_row3').style.display != "none") {
		scores = document.getElementById('yahtzee_bonus_points3').style.backgroundColor;
		if(scores != "yellow") {
			document.getElementById('yahtzee_bonus_points3').innerHTML = calcYahtzeeBonus();
			document.getElementById('yahtzee_bonus_points3').style.color = "red";
		}
	}
	// Bonus Yahtzee 4, if visible
	if(document.getElementById('bonus_yahtzee_row4').style.display != "none") {
		scores = document.getElementById('yahtzee_bonus_points4').style.backgroundColor;
		if(scores != "yellow") {
			document.getElementById('yahtzee_bonus_points4').innerHTML = calcYahtzeeBonus();
			document.getElementById('yahtzee_bonus_points4').style.color = "red";
		}
	}
	// Bonus Yahtzee 5, if visible
	if(document.getElementById('bonus_yahtzee_row5').style.display != "none") {
		scores = document.getElementById('yahtzee_bonus_points5').style.backgroundColor;
		if(scores != "yellow") {
			document.getElementById('yahtzee_bonus_points5').innerHTML = calcYahtzeeBonus();
			document.getElementById('yahtzee_bonus_points5').style.color = "red";
		}
	}
	// Chance
	scores = document.getElementById('chance_points').style.backgroundColor;
	if(scores != "yellow") {
		document.getElementById('chance_points').innerHTML = calcChance();
		document.getElementById('chance_points').style.color = "red";
	}
}
function getHighScores() {
	var hs2 = localStorage.getItem("high_score2") != null ? localStorage.getItem("high_score2") : "N/A";
	var hs3 = localStorage.getItem("high_score3") != null ? localStorage.getItem("high_score3") : "N/A";
	var hs4 = localStorage.getItem("high_score4") != null ? localStorage.getItem("high_score4") : "N/A";
	var hs6 = localStorage.getItem("high_score6") != null ? localStorage.getItem("high_score6") : "N/A";
	$('#high_score2').html(hs2);
	$('#high_score3').html(hs3);
	$('#high_score4').html(hs4);
	$('#high_score6').html(hs6);
}
function checkUpdateHighScore() {
	var highScore = localStorage.getItem("high_score" + rangeMax);
	var thisScore = $('#grand_total_points').html();

	if(parseInt(thisScore) > parseInt(highScore) || highScore == null) {
		window.alert("You set a new high score!");
		localStorage.setItem("high_score" + rangeMax, thisScore);
		getHighScores();
	}
}
function resetHighScores() {
	var confirm = window.confirm("Be careful! You are about to reset your high scores!");
	if(confirm) {
		localStorage.removeItem("high_score2");
		localStorage.removeItem("high_score3");
		localStorage.removeItem("high_score4");
		localStorage.removeItem("high_score6");
		getHighScores();
	}
}
function clearCard() {
	location.href = "index.html";
}
function postScore() {
	var score = document.getElementById('grand_total_points').innerHTML;
	var table = document.getElementById('previous_scores_table');
	if(score != '') {
		var row = table.insertRow(-1);
		var cell = row.insertCell(0);
		cell.style.backgroundColor = 'white';
		cell.innerHTML = score;
	}
}
function toggleScorecard() {
	$('#score_card').toggle();
}
function mainMenu() {
	navigator.notification.confirm(
		"Are you sure you want to end this game?",	//message
		confirmMainMenu,	//callback function
		"Confirmation",	//title
		"Yes, No"	//button labels
	);
}
function confirmMainMenu(btnIndex) {
	if(btnIndex == 1) {
		location.href = "index.html";
	}
}
function exitApp() {
	navigator.notification.confirm(
		"Are you sure you want to exit?", //message
		confirmExit,	//callback function
		"Confirmation",	//title
		"Yes, No"	//button labels
	);
}
function confirmExit(btnIndex) {
	if(btnIndex == 1) {
		navigator.app.exitApp();
	}
}
function closeNavbar() {
	if($('#bs-example-navbar-collapse-1').hasClass('in')) {
		$('.navbar-toggle').addClass('collapsed');
		$('#bs-example-navbar-collapse-1').removeClass('in');
		$('#iconBars').css('margin-left', '-15px').css('margin-right', '5px');
	}
}