var numOfRolls = 3;	//Global var for number of rolls

var possibleColors = ["#FF0000", "#00FF00", "#0000FF", "#FFFF00", "#00FFFF", "#FFFFFF"];
var colors = ["#FF0000", "#00FF00", "#0000FF", "#FF0000", "#00FF00", "#0000FF", "#FF0000", "#00FF00", "#0000FF", "#FF0000", "#00FF00", "#0000FF"];
var numbers = ["1", "2", "3", "1", "2", "3", "1", "2", "3", "1", "2", "3"];

var startAngle = 0;
var arc = Math.PI / 6;
var spinTimeout = null;

var spinArcStart = 1;
var spinTime = 0;
var spinTimeTotal = 0;

var ctx;

function draw() {
	setRange();
	drawRouletteWheel();
}

function drawRouletteWheel() {
	var canvas = document.getElementById("wheel");
	if (canvas.getContext) {
	  	var outsideRadius = 80;
	  	var textRadius = 64;
	  	var insideRadius = 50;
	  
	  	ctx = canvas.getContext("2d");
	  	ctx.clearRect(0,0,200,200);
	  
	  
	  	ctx.strokeStyle = "black";
	  	ctx.lineWidth = 2;
	  
	  	ctx.font = 'bold 14px sans-serif';
	  
	  	for(var i = 0; i < 12; i++) {
		    var angle = startAngle + i * arc;
		    ctx.fillStyle = colors[i];
		    
		    ctx.beginPath();
		    ctx.arc(100, 100, outsideRadius, angle, angle + arc, false);
		    ctx.arc(100, 100, insideRadius, angle + arc, angle, true);
		    ctx.stroke();
		    ctx.fill();
		    
		    ctx.save();
		    ctx.shadowOffsetX = -1;
		    ctx.shadowOffsetY = -1;
		    ctx.shadowBlur    = 0;
		    ctx.shadowColor   = "rgb(220,220,220)";
		    ctx.fillStyle = "black";
		    ctx.translate(100 + Math.cos(angle + arc / 2) * textRadius, 100 + Math.sin(angle + arc / 2) * textRadius);
		    ctx.rotate(angle + arc / 2 + Math.PI / 2);
		    var text = numbers[i];
		    ctx.fillText(text, -ctx.measureText(text).width / 2, 0);
		    ctx.restore();
	  	} 
	  
	  	//Arrow
	  	ctx.fillStyle = "black";
	  	ctx.beginPath();
	  	ctx.moveTo(100 - 4, 100 - (outsideRadius + 5));
	  	ctx.lineTo(100 + 4, 100 - (outsideRadius + 5));
	  	ctx.lineTo(100 + 4, 100 - (outsideRadius - 5));
	  	ctx.lineTo(100 + 9, 100 - (outsideRadius - 5));
	  	ctx.lineTo(100 + 0, 100 - (outsideRadius - 13));
	  	ctx.lineTo(100 - 9, 100 - (outsideRadius - 5));
	  	ctx.lineTo(100 - 4, 100 - (outsideRadius - 5));
	  	ctx.lineTo(100 - 4, 100 - (outsideRadius + 5));
	  	ctx.fill();
	}
}

function spin() {
	spinAngleStart = Math.random() * 10 + 10;
	spinTime = 0;
	spinTimeTotal = Math.random() * 3 + 4 * 1000;
	rotateWheel();
	$('#spin').hide();
}

function rotateWheel() {
	spinTime += 30;
	if(spinTime >= spinTimeTotal) {
	  stopRotateWheel();
	  return;
	}
	var spinAngle = spinAngleStart - easeOut(spinTime, 0, spinAngleStart, spinTimeTotal);
	startAngle += (spinAngle * Math.PI / 180);
	drawRouletteWheel();
	spinTimeout = setTimeout('rotateWheel()', 30);
}

function stopRotateWheel() {
	clearTimeout(spinTimeout);
	var degrees = startAngle * 180 / Math.PI + 90;
	var arcd = arc * 180 / Math.PI;
	var index = Math.floor((360 - degrees % 360) / arcd);
	ctx.save();
	ctx.font = 'bold 30px sans-serif';
	var text = numbers[index]
	ctx.fillText(text, 100 - ctx.measureText(text).width / 2, 100 + 10);
	ctx.restore();
	numOfRolls = text;
	$('#spinner').hide();
	$('#dice_wrapper').show();
	$('#rolls_remaining').val(numOfRolls);
}

function easeOut(t, b, c, d) {
	var ts = (t/=d)*t;
	var tc = ts*t;
	return b+c*(tc + -3*ts + 3*t);
}

function setRange() {
	if(rangeMax != 3) {
		for(var i=0; i < 12; i++) {
			colors[i] = possibleColors[i % rangeMax];
		}
		for(var i=0; i < 12; i++) {
			numbers[i] = (i % rangeMax) + 1;
		}
	}
}